// Use Timer/Counter1 to generate a 1MHz square wave on Arduino pin 9.
// J.Christensen 27Apr2012

// MrWolf@EEVblog changed from 1MHz to 32.78688524590164 kHz (Calculated)
// For DSO auto-measurements test
// http://www.eevblog.com/forum/testgear/testing-dso-auto-measurements-accuracy-across-timebases/

// Actual readings with Arduino Uno R1:
// 32.734176 kHz (Siglent SDG2000X)
// 32.734 kHz (Agilent U1272A)
// 32.7345 kHz (Rigol DS1000Z)
// Risetime 5ns, jitter +-100ps (Rigol DS1000Z)

// Actual readings with Arduino Uno R3:
// 32.770604 kHz (Siglent SDG2000X)
// 32.771 kHz (Agilent U1272A)
// 32.771 kHz (Rigol DS1000Z)
// Risetime 4ns, fall 6ns, jitter +-100ps (Rigol DS1000Z)

// If you have hardware counter(s), please measure your Arduino
// also and change frequency value in report accordingly.

// NB! Output on Arduino pin ~9

void setup(void)
{
    cli();
    
    DDRB = _BV(DDB1);                 // set OC1A/PB1 as output (Arduino pin D9, DIP pin 15)
    TCCR1A = _BV(COM1A0);             // toggle OC1A on compare match
    OCR1A = 243;                      // top value for counter
    TCCR1B = _BV(WGM12) | _BV(CS10);  // CTC mode, prescaler clock/1
    
    sei();
}

void loop(void)
{
}

